'use strict';

var _config = require('./config');

var _config2 = _interopRequireDefault(_config);

var _fs = require('fs');

var _fs2 = _interopRequireDefault(_fs);

var _bridge = require('./libs/bridge');

var _bridge2 = _interopRequireDefault(_bridge);

var _nodeTelegramBotApi = require('node-telegram-bot-api');

var _nodeTelegramBotApi2 = _interopRequireDefault(_nodeTelegramBotApi);

var _irc = require('irc');

var _irc2 = _interopRequireDefault(_irc);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var _DEBUG_ = process.env.DEBUG || false;

var bridges = [];

var tgBot = new _nodeTelegramBotApi2.default(_config2.default.telegram.token, {
    polling: true
});

var bridgeTasks = _config2.default.bridges.map(function (bridge) {
    return new Promise(function (resolve, reject) {
        var options = {
            config: bridge,
            tgBot: tgBot,
            ircLib: _irc2.default
        };

        var ircGramBridge = new _bridge2.default(options);

        _fs2.default.readFile(bridge.users_db, function (err, data) {
            if (err) {
                data = '[]';
            }

            try {
                var users = JSON.parse(data);

                users.forEach(function (user) {
                    if (_DEBUG_) {
                        console.log('Configuring ' + user.username + '...');
                    }

                    ircGramBridge.addUser(user);
                });
            } catch (e) {
                reject(e);
            }

            bridges.push(ircGramBridge);

            resolve();
        });
    });
});

Promise.all(bridgeTasks).then(function () {
    console.log('Bridges ready');
}).catch(function (err) {
    console.log(err.stack);
    process.exit(1);
});