'use strict';
/* jshint esversion: 6, node: true */

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _fs = require('fs');

var _fs2 = _interopRequireDefault(_fs);

var _nodeTelegramBotApi = require('node-telegram-bot-api');

var _nodeTelegramBotApi2 = _interopRequireDefault(_nodeTelegramBotApi);

var _events = require('events');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var _DEBUG_ = process.env.DEBUG || false;

var TGBot = function () {
  function TGBot(options) {
    _classCallCheck(this, TGBot);

    this.options = options;
    this.tgBot = new _nodeTelegramBotApi2.default(options.telegram.token, { polling: true });

    this.bindEvents();
  }

  _createClass(TGBot, [{
    key: 'bindEvents',
    value: function bindEvents() {
      var _this = this;

      this.tgBot.on('message', function (msg) {
        var chatId = msg.chat.id;
        if (_DEBUG_) {
          console.log(msg);
        }

        if (!_this.ircConnections[msg.from.id]) {
          _this.addUser(new User(msg.from));
        }

        if (_this.ircConnections[msg.from.id]) {
          _this.ircConnections[msg.from.id].say(_this.options.irc.channel, msg.text);
        }
      });

      this.tgBot.on('new_chat_participant', function (msg) {
        if (_DEBUG_) {
          console.log(msg);
        }

        if (!_this.ircConnections[msg.new_chat_participant.id]) {
          _this.addUser(new User(msg.new_chat_participant));

          _this.updateUsersDb();
        }
      });

      this.tgBot.on('left_chat_participant', function (msg) {
        if (_DEBUG_) {
          console.log(msg);
        }

        if (_this.ircConnections[msg.left_chat_participant.id]) {
          _this.removeUser(msg.left_chat_participant.id);
        }
      });
    }
  }, {
    key: 'updateUsersDb',
    value: function updateUsersDb() {
      var _this2 = this;

      var result = Object.keys(this.irc2tgUserMapping).map(function (userKey) {
        return {
          id: _this2.irc2tgUserMapping[userKey].id,
          username: _this2.irc2tgUserMapping[userKey].username,
          first_name: _this2.irc2tgUserMapping[userKey].first_name,
          last_name: _this2.irc2tgUserMapping[userKey].last_name
        };
      });

      _fs2.default.writeFile(this.options.users_db, JSON.stringify(result, null, 2), function (wrErr) {
        if (_DEBUG_) {
          console.log(wrErr);
        }
      });
    }
  }]);

  return TGBot;
}();

exports.default = TGBot;